clear all;

% Read the training data
t_0170 = load(...);
t_0187 = ...;
t_0201 = ...;
% Form the data matrix that will be used for training the ANN
dataTrain = [
        ...
    ];

% Standardize the training input
dataTrainStandardized = ...;

% Decompose the training data into predictor vs. response datasets
XTrain = ...;
YTrain = ...;

% Secify the number of predictors (features), outputs (responses) and
% the size of the hidden layer (i.e. the "memory" size)
numFeatures = ...;
numResponses = ...;
numHiddenUnits = ...;

% Setup the network layers
layers = [ ...
    sequenceInputLayer(numFeatures)  % this reads the sequence
    lstmLayer(numHiddenUnits)  % LSTM network itself
    fullyConnectedLayer(numResponses)  % again pool the data using standard perceptron
    regressionLayer];

% Specify the training options
options = trainingOptions('adam', ...  % adaptive moment estimation, improvement over stochastic gradient descent
    'MaxEpochs',140, ...
    'GradientThreshold',1, ...  % apply gradient clipping
    'InitialLearnRate',0.005, ...  % this is the "mu", higher values mean faster but possibly less optimal convergence
    'LearnRateSchedule','piecewise', ...
    'LearnRateDropPeriod',80, ...  % number of epochs to initiate rate drop
    'LearnRateDropFactor',0.2, ...  % learn rate drop multiplier, i.e. 0.2*0.005
    'Verbose',true, ...
    'Plots','training-progress');

% Do not train the network every time, but only if the pre-trained data is
% missing
stored_net_file = 'traffic_lstm_en.mat';
if ~isfile(...)
    net = trainNetwork(...);
    save(stored_net_file, 'net');
else
    % This is going to "magically" load the `net` from the file.
    load(stored_net_file);
end

% Read the testing data
v_0170 = load('testing/...');
v_0187 = ...;
v_0201 = ...;
% Form the data matrix that will be used for testing the ANN
dataTest = [
		...
    ];

% Standardize the test data
dataTestStandardized = ...;
XTest = dataTestStandardized(:,1:3)';

% Update the internal state of the LSTM ANN using the training data
net = predictAndUpdateState(...);
% Assume that the testing data starts where the training data ended and
% try to predict the output for the testing data
[net,YPred] = predictAndUpdateState(...);

% De-standardise the data: multilply by standard error estimate, add mean estimate
YPred = ...;
% Get the true testing outputs that shall be compared with YPred
YTest = ...;

% Compute the RMSE we made on predicting the data
rmse = ...

% Plot the results including the RMSE
figure(3)
%
subplot(2,1,1)
plot(YTest)
hold on
plot(YPred,'.-')
hold off
legend(["Observed" "Forecast"])
ylabel("Vehicles")
title("Forecast")
%
subplot(2,1,2)
stem(YPred - YTest)
xlabel("Minues")
ylabel("Error")
title("RMSE = " + rmse)

